/*   
 *
 *   Copyright (c) 2003 Lonesome, OSDev Group & Peter Zotov
 *
 *   http://tyros.sourceforge.net/
 *   http://sourceforge.net/projects/tyros/
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2, or (at your option)
 *   any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program (see the file COPYING); if not, write to the
 *   Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 *   Boston, MA  02111-1307, USA
 *
 *
 */

#include <tyros.h>
#include <ntx.h>
#include <../hal/ia32/include/ktty.h>

int main(int argc, char **argv)
{
  if(argc < 2) {
    printf("edit what?\n");
  } else {
    edit_file(argv[1]);
  }
}



int edit_file(char *filename)
{
  int fd;
  char buffer[0x10010];
  char command[0x110];
  int size;
  int line;
  int lb;
  int nlb;

  fd = open(filename, O_CREAT);
  
  if(fd == -1) {
    printf("can't open %s!\n", filename);
    return 0;
  }
  
  size = read(fd, buffer, 0x10000);

  printf("editing '%s', size: %i bytes\n", filename, size);
  
  for(;;) {
    printf("enter command (v/e/a/?):");
    fgets(command, 0x100,stdin);

    switch(command[0]) {
    case 'v':
      line = atoi(&command[2]);
      lb = getline(buffer, line);
      nlb = getline(buffer, line + 1);
      
      if(lb == -1) {
	printf("line %i doesn't exist\n", line);
      } else {
	printf("lb = %i, nlb = %i\n", lb, nlb);
	
	if(nlb == -1) {
	  printf("%s", line, &buffer[lb]);
	} else {
	  printf("block length: %i bytes\n", nlb - lb);
	  write(stdout, &buffer[lb], nlb - lb);
	}
      }
      break;

    case 'e':

      break;

    case 'a':

      break;

    case '?':
      printf("v <line> :view line \n"
	     "e <line> :edit line \n"
	     "a        :append line\n"
	     "?        :this text\n");
      break;
    }
    
  }

}

int getline(char *buffer, int count)
{
  int i;
  int cline;
  
  if(count == 1) {
    return 0;
  }

  count--;

  cline = 0;

  for(i = 0; i < 0x10000; i++) {
    if(buffer[i] == 0) {
      return -1;
    }
    if(buffer[i] == '\n') {
      cline++;
      
      if(cline == count) {
	return i + 1;
      }
    }
  }
  return -1;
}
