/*   
 *
 *   Copyright (c) 2003 Lonesome, OSDev Group & Peter Zotov
 *
 *   http://tyros.sourceforge.net/
 *   http://sourceforge.net/projects/tyros/
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2, or (at your option)
 *   any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program (see the file COPYING); if not, write to the
 *   Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 *   Boston, MA  02111-1307, USA
 *
 *
 */


#include <tyros.h>
#include <ntx.h>

void list_dir(char *directory);

int main(int argc, char *argv[])
{
int i;
char buffer[PATH_MAX];

i = 0;
 
if(argc > 1) 
 for(i = 1; i < argc; i++)
  list_dir(argv[i]);
else 
 {
 getcwd(buffer, PATH_MAX);
 list_dir(buffer);
 }
}

#define FILENAME_LEN 20

void list_dir(char *directory)
{
char buffer[0x1000];
int i, j;
int dir, start;
int num;
ntx_stat_t statbuf;
int fd;

dir = open(directory, 0);
if(dir == -1) 
 {
 printf("ls: error opening '%s'!\n", directory);
 return 0;
 }
  
num = read (dir,buffer,0x1000);
if(num == -1 || num == 0)  
 {
 printf("ls: error getting directory listing of %s!\n", directory);
 return 0;
 }

start = 0;  
for(i = 0; i < num; i++) 
 {
 if(buffer[i] == 0) 
  {
  printf("%s", &buffer[start]);
  for(j = 0; j < (FILENAME_LEN - strlen(&buffer[start])); j++)
   putchar(' ');

  fd = open(&buffer[start], 0);
  fstat(fd, &statbuf);
  close(fd);
      
  start = i + 1;
 }
}
close(dir);
printf("\n");
return 0;
}