/*   
 *
 *   Copyright (c) 2003 Lonesome, OSDev Group & Peter Zotov
 *
 *   http://tyros.sourceforge.net/
 *   http://sourceforge.net/projects/tyros/
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2, or (at your option)
 *   any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program (see the file COPYING); if not, write to the
 *   Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 *   Boston, MA  02111-1307, USA
 *
 *
 */

#include <tyros.h>
#include <ntx.h>

extern char **environ;

int is_divisor(char c);
void get_exe_name(char *proc, char *exename);

char *getsn (char *buffer, int count)
{
fgets(count, buffer, stdin);
}

int main(int argc, char *argv[])
{
char buf[0x1000];
char *arglist[0x100];
int i;
int last, start;
int argcount;
int buflen;

if(argc > 1)
 if(argv[1])
  {
  execute(argc-1, &argv[1]);
  return 0;
  }

for(;;)
 {
 char cwd[PATH_MAX];
 getcwd(cwd, PATH_MAX);
 if(strlen(cwd) > 1)
  cwd[strlen(cwd) - 1] = 0;
 printf("%s# ", cwd);

 buf[0x1000-1] = '\0';
 getsn(buf,0x1000);
 if(*buf == '\0')
  continue;
 
 char* buffer = buf;
 last = 0;
 argcount = 0;

 buflen = strlen(buffer);

 for(i = 0; i < buflen; i++) 
  {
  if(is_divisor(buffer[i])) 
   {
   buffer[i] = 0;
   arglist[argcount] = &buffer[last];
  
   argcount++;
	
   last = i + 1;

   while(is_divisor(buffer[last]))
    {
    last++;
    i++;
    }
   }
  }
  arglist[argcount] = NULL;
  execute(argcount, arglist);
 }
}


int is_divisor(char c)
{
if(c == ' ' || c == '\n' || c == 0) 
 {
 return 1;
 }
else 
 {
 return 0;
 }
}

int execp(char *filename, char **argv, char **envp)
{
char *PATH[0x100];
char buffer[PATH_MAX + 0x10];
char *start;
int argc;
int i;
int finish;
char *ret = NULL;;
file_t f;
char *envpath;
char newpath[PATH_MAX + 0x10];
char progname[PATH_MAX + 0x10];
int child;
  
if(*filename != '/') 
 {
 envpath = getenv("PATH");
 
 if(envpath == NULL) 
  {
  printf("PATH = NULL!\n");
  //strcpy(progname, filename);
  //    return 0;
  } 
 else 
  {
    //    strcpy(progname, filename);
    //    return 0;
  }

 strncpy(buffer, envpath, PATH_MAX);

 argc = 0;
 i = 0;
 finish = 0;

 start = buffer;
 for(;;) 
  {
  if(buffer[i] == ';' || buffer[i] == 0) 
   {
   if(buffer[i] != 0) 
    {
    buffer[i] = 0;
    PATH[argc] = start;
    argc++;
    start = &buffer[i + 1];
    } 
   else 
    {
    PATH[argc] = start;
    argc++;
    start = &buffer[i + 1];
    finish = 1;
    }      
   if(*start == 0 || finish == 1) 
    break;
   }
  i++;
  }
 for(i = 0; i < argc; i++) 
  {
  strncpy(newpath, PATH[i], PATH_MAX);
  strncat(newpath, "/", 3);
  strncat(newpath, filename, PATH_MAX);

  child = ntx_launch(newpath, argv, envp);

  if(child != -1) 
   return child;
  } 
 }
return ntx_launch(filename, argv, envp); 
}

int execute(int argc, char **argv)
{
int child;
int status;

if(!strcmp(argv[0], "cd"))
 { 
 if(argv[1])
  if(!strcmp(argv[1], ".."))
   builtin_up(argc, argv);
  else
   builtin_go(argc, argv);
 }
else if(!strcmp(argv[0], "pwd"))
 builtin_pwd(argc, argv);
else if(!strcmp(argv[0], "load"))
 builtin_load (argc, argv);
else if(!strcmp(argv[0], "unload"))
 builtin_unload (argc, argv);
else if(!strcmp(argv[0], "ps"))
 builtin_ps(argc, argv);
else if(!strcmp(argv[0], "rm"))
 builtin_rm(argc, argv);
else if(!strcmp(argv[0], "mkdir"))
 builtin_mkdir (argc, argv);
else if(!strcmp(argv[0], "mount"))
 builtin_mount (argc, argv);
else if(!strcmp(argv[0], "touch"))
 builtin_touch(argc, argv);
else if(!strcmp(argv[0], "clear"))
 putchar(0x0C);
else if(!strcmp(argv[0], "help"))
 {
 printf("pwd    - get current directory\n");
 printf("load   - load kernel extension\n");
 printf("unload - unload kernel extension\n");
 printf("ps     - get a process list\n");
 printf("rm     - remove a file\n");
 printf("mkdir  - make a directory\n");
 printf("mount  - mount a device to directory\n");
 printf("touch  - try to create a file\n");
 printf("clear  - clear screen\n");
 printf("help   - this text\n");
 }
else 
 {
 child = execp(argv[0], argv, environ);
 if(child == -1) 
  {
  printf("Error launching '%s'!\n", argv[0]);
  return 0;
  }
 if(!strcmp(argv[argc - 1],"&"))
  {
  argv[argc-1] = NULL;
  argc--;
  printf("Launched '%s' in background (PID=%d)\n", argv[0], child);
  }
 else
  waitpid(child, &status, 0);
 }
}

int builtin_load (int argc, char **argv)
{
int fd;
int res;

if(argv[1] == NULL) 
 {
 printf("Usage: load <module file name>\n");
 return -1;
 }

fd = open("/sys/control/kex", 0);
if(fd == -1) 
 {
 printf("Can't open /sys/control/kex!\n");
 return -1;
 }
  
res = write (fd, argv[1], strlen(argv[1]));
if(res == -1)
 printf("Error loading '%s'!\n", argv[1]);
else
 printf("Module '%s' was succesfully loaded.\n", argv[1]);
}

int builtin_unload (int argc, char **argv)
{
int fd;
int res;

if(argv[1] == NULL) 
 {
 printf("Usage: unload <module name>\n");
 return -1;
 }
  
fd = open("/sys/control/unkex", 0);
if(fd == -1) 
 {
 printf("Can't open /sys/control/unkex!\n");
 return -1;
 }
  
res = write (fd, argv[1], strlen(argv[1]));
if(res == -1)  
 printf("Error unloading '%s'!\n", argv[1]);
else
 printf("'%s' was succesfully unloaded.\n", argv[1]); 
}

int builtin_touch (int argc, char **argv)
{
int fd;

if(argv[1] != NULL) 
 {
 fd = open(argv[1], O_CREAT);
 if(fd == -1)
  printf("Error touching '%s'!\n", argv[1]);
 else
  close(fd);
 } 
else 
 printf("Usage: touch <file name>\n");
}

int builtin_mount (int argc, char **argv)
{
if(argc < 4)
 printf("usage: mount <device> <directory> <fstype>\n");
else
 mount(argv[1], argv[2], argv[3], 0, NULL);
}

int builtin_mkdir(int argc, char **argv)
{
if(argv[1] != NULL) 
 {
 if(mkdir(argv[1]) == -1)
  printf("Error making '%s'!\n", argv[1]);
 else
  printf("Directory '%s' is made.\n", argv[1]);
 }
else
 printf("Usage: mkdir <directory name>\n");
}

int builtin_rm (int argc, char **argv)
{
if(argv[1] != NULL) 
 {
 if(unlink(argv[1]) == -1) 
  printf("Error removing '%s'!\n", argv[1]);
 else 
  printf("File '%s' removed.\n", argv[1]);
 }
}

int builtin_ps(int argc, char **argv)
{
char buffer[0x1000];
char exename[0x100];
int procs[0x1000];
int pcount;
int fd;
int len;
int i;
int last;

fd = open("/sys/info/processes", 0);
  
if(fd == -1)
 printf("Cannot open /sys/info/processes!\n");
  
len = read(fd, buffer, 0x1000);
  
pcount = 0;
last = 0;

for(i = 0; i < len; i++) 
 {
 if(buffer[i] == ' ')
  {
  buffer[i] = 0;
  get_exe_name(&buffer[last], exename);
      
  printf("PID %s File '%s'\n", &buffer[last], exename);
  last = i + 1;
  }
 } 
}

void get_exe_name(char *proc, char *exename)
{
char filename[PATH_MAX];
int fd;

sprintf(filename, "/sys/proc/%s/exe", proc);
fd = open(filename, 0);
  
if(fd == -1)
 strcpy(exename, "unknown");
else
 read(fd, exename, PATH_MAX);
}

int builtin_go(int argc, char **argv)
{
if(chdir(argv[1]) == -1) 
 printf("Cannot change directory to '%s'!\n", argv[1]);
}

int builtin_pwd (int argc, char **argv)
{
char cwd[PATH_MAX];
getcwd(cwd, PATH_MAX);
printf("%s\n", cwd);
}

int builtin_up(int argc, char **argv)
{
char cwd[PATH_MAX];
char *d;

getcwd(cwd, PATH_MAX);
d = strrchr(cwd, '/');
  
if(d != cwd)
 {
 *d = 0;
 d = strrchr(cwd, '/');
 if(d != cwd) 
  *d = 0;
 else
  d[1] = 0;
 if(chdir(cwd) == -1)
  printf("Cannot change directory to '%s'!\n", cwd);
  }
}