/*   
 *
 *   Copyright (c) 2003 Lonesome, OSDev Group & Peter Zotov
 *
 *   http://tyros.sourceforge.net/
 *   http://sourceforge.net/projects/tyros/
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2, or (at your option)
 *   any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program (see the file COPYING); if not, write to the
 *   Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 *   Boston, MA  02111-1307, USA
 *
 *
 */

#ifndef _BLKDEV_H_
#define _BLKDEV_H_

#define MAX_BLKDEV 0x1000

#define BLKDEV_READ  0
#define BLKDEV_WRITE 1
#define BLKDEV_INFO  2

typedef struct blkdev_opeartion_st {
  fsize_t start_block;
  fsize_t block_count;
  int cmd;
  void* buf;
} blkdev_operation_t;

typedef struct blkdev_driver_struct {
  char *name;
  int (*driver) (int minor, blkdev_operation_t op);
} blkdev_driver_t;

typedef struct blkdev_info_struct {
  int block_size;
  int block_count; 
} blkdev_info_t;

#endif
