/*   
 *
 *   Copyright (c) 2003 Lonesome, OSDev Group & Peter Zotov
 *
 *   http://tyros.sourceforge.net/
 *   http://sourceforge.net/projects/tyros/
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2, or (at your option)
 *   any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program (see the file COPYING); if not, write to the
 *   Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 *   Boston, MA  02111-1307, USA
 *
 *
 */

#include <tyros.h>
#include <ntx.h>
#include <exec.h>

task_image_t load_raw_image (process_t *process, void *image, int size)
{
  int i;
  void * ptask_entry;
  unsigned int pagedir;
  task_image_t task_image;
  unsigned int total_pages;
  unsigned int phys_page;

  pagedir = process->pagedir;

  total_pages = mem_to_pages(size);

  
  for(i = 0; i < total_pages; i++) {
    phys_page = alloc_pmem(1);
    
    memcpyl (phys_page, image + i*PAGE_SIZE, 1024);

    map_memory_page(USER_ADDRESS_SPACE_START + i*PAGE_SIZE,//virtual
		    phys_page, //physical
		    pagedir,0x7);
  }
 
  task_image.start = image;
  task_image.size = size;
  
  return task_image;
}

