/*   
 *
 *   Copyright (c) 2003 Lonesome, OSDev Group & Peter Zotov
 *
 *   http://tyros.sourceforge.net/
 *   http://sourceforge.net/projects/tyros/
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2, or (at your option)
 *   any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program (see the file COPYING); if not, write to the
 *   Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 *   Boston, MA  02111-1307, USA
 *
 *
 */

#include <tyros.h>
#include <ntx.h>
#include <ntxbase.h>
#include <vfs.h>
#include <filesystems.h>

int read_vfsroot (id_t lid, fsize_t start, fsize_t size, void *buffer, file_t device)
{
  char bf[0x1010];
  int i;
  nsentry_t *nse;
  char *localbuf;
  int ret;
  int id = (int) lid;

  localbuf = bf;
  nse = id;
  i = 0;

  //  if(nse->nse_type == NSE_OBJECT && nse->nsstatus.vfsid == VFS_MEMFS) {
  //    printf("RVFSROOT: nse_ident: %s\n", nse->nsstatus.ident);
  //    return read_memfs(nse, start, size, buffer, device);
  //  }
  
  while(nse->nsentry[i] != NULL) {
    localbuf += sprintf(localbuf,"%s", nse->name[i]);
    //    printf("Reading from VFS: %s\n", nse->name[i]);
    localbuf++;
    i++;
  }

  *localbuf = 0;
  *(localbuf + 1) = 0;

  ret = read_mem(bf, (localbuf - bf), (unsigned int) start, (unsigned int) size, buffer);
  
  return ret;
}

int mkdir_vfsroot (id_t lid, char *name, int *mode, file_t device)
{
  nsentry_t *id = (nsentry_t *) lid;
  
  //  printf("mkdir_vfsroot, name: %s\n", name);
  
  add_nsentry(id, 
	      create_nsentry(NSE_CONTAINER),
	      name);
  
  return 0;
}

int stat_vfsroot (id_t lid, ntx_stat_t *buffer, file_t device)
{
  printf("statting vfsroot\n");
  return -1;
}

int write_vfsroot (id_t lid, int start, int size, void *buffer, nsentry_t *nsentry)
{
  //write to VFSRoot ??!! :)
  return -1;
}

int unlink_vfsroot (id_t lid, file_t device)
{
  return -1;
}

void init_vfs()
{
  vfs_handler_t *vfsroot_handler;
  
  vfsroot_handler = calloc(sizeof(vfs_handler_t), 1);
  
  vfsroot_handler->read_func = &read_vfsroot;
  vfsroot_handler->write_func = &write_vfsroot;
  vfsroot_handler->stat_func = &stat_vfsroot;
  vfsroot_handler->unlink_func = &unlink_vfsroot;
  vfsroot_handler->mkdir_func = &mkdir_vfsroot;

  add_vfs_handler (VFS_VFSROOT, vfsroot_handler);
}
