/*   
 *
 *   Copyright (c) 2003 Lonesome, OSDev Group & Peter Zotov
 *
 *   http://tyros.sourceforge.net/
 *   http://sourceforge.net/projects/tyros/
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2, or (at your option)
 *   any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program (see the file COPYING); if not, write to the
 *   Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 *   Boston, MA  02111-1307, USA
 *
 *
 */

#include <tyros.h>

#include "ihandl.h"

#define ATTACHED_NONE -1

func_t *attached_handler;
int *attached_header;
int *attached_flags;

void init_core_ints()
{
  int i;
  
  attached_handler = (int *) alloc_pmem (mem_to_pages(sizeof(func_t) * 255));
  attached_header = (int *) alloc_pmem (mem_to_pages(sizeof(int) * 255));
  attached_flags = (int *) alloc_pmem (mem_to_pages(sizeof(int) * 255));

  for(i = 0x21; i < 256; i++) {
    attached_handler[i] = ATTACHED_NONE;
  }
}

int attach (int vector, int header, int flags)
{
  task_t *task = tasks.task[tasks.current];
  
  if(task->pl == 0) {
    if(vector > 0x20 && vector < 256 && vector != 0x77) {
      
      attached_handler[vector] = tasks.current;
      attached_header[vector] = header;
      attached_flags[vector] = flags;
      
      return 0;
      
    } else {
      return -1;
    }
    
  } else {
    return -1;
  }
}

int detach (int vector, int flags)
{
  task_t *task = tasks.task[tasks.current];
  if(task->pl == 0) {
    if(vector > 0x20 && vector < 256 && vector != 0x77) {
    
      attached_handler[vector] = 0;
    
      return 0;
    
    } else {
      return -1;
    }
  } else {
    return -1;
  }
}

int int_handler (int vector)
{
  message_t msg;
  int backpagedir;
  void (*handler)();

  //  printf("Unrecognized interrupt %x!\n", vector);

  //hack... again
  //delay has to be working even until task manager (and thus int_timer) is active
  if(vector == 0x20){
    ticks_counter++;
    return 0;
  }

  //  printf("unhandled interrupt: %i\n", vector);

  return 0;

  if(attached_handler[vector] != ATTACHED_NONE) {
    
    switch (attached_flags[vector]) {
      
    case AT_REALTIME:
      
      isem_disable();
    
      backpagedir = tasks.task[tasks.current]->pagedir;
      handler = attached_header[vector];
    
      load_cr3(tasks.task[attached_handler[vector]]->pagedir);
      handler();
      load_cr3(backpagedir);
    
      msg.header = attached_header[vector];
      msg.size = 0;

      isem_enable();
      
      break;
    
    default:
      
      break;
    }
      
  } else {
    //ignore interrupt
  }
  
  //  i_enable();
  
}
