/*   
 *
 *   Copyright (c) 2003 Lonesome, OSDev Group & Peter Zotov
 *
 *   http://tyros.sourceforge.net/
 *   http://sourceforge.net/projects/tyros/
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2, or (at your option)
 *   any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program (see the file COPYING); if not, write to the
 *   Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 *   Boston, MA  02111-1307, USA
 *
 *
 */

#ifndef _IPC_H_
#define _IPC_H_

int ipc_set_sighandler(signum_t signum, func_t func);
int ipc_send_signal(tid_t tid, signum_t signum);


int ipc_link_port (port_t port, tid_t to, port_t target, int flags);
int ipc_reinit_port (port_t port, int flags);
int ipc_msg_send (tid_t tid, message_t *msg, int flags);
int ipc_msg_recv (message_t *msg, int flags);
int ipc_msg_wait ();
int is_msg_queue_empty (msgqueue_t *msgq);
int is_msg_queue_full (msgqueue_t *msgq);




#endif
