/*   
 *
 *   Copyright (c) 2003 Lonesome, OSDev Group & Peter Zotov
 *
 *   http://tyros.sourceforge.net/
 *   http://sourceforge.net/projects/tyros/
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2, or (at your option)
 *   any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program (see the file COPYING); if not, write to the
 *   Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 *   Boston, MA  02111-1307, USA
 *
 *
 */

#include <tyros.h>
#include <assert.h>
#include "mailbox.h"

mailbox_t *mailbox_alloc()
{
  return malloc(sizeof(mailbox_t));
}

void mailbox_cleanup(mailbox_t *mailbox)
{
  free(mailbox);
}

message_t *message_alloc()
{
  return malloc(sizeof(message_t));
}

int mailbox_init (mailbox_t *mailbox)
{
  mailbox->msg = NULL;
  return 0;
}

int mailbox_put (mailbox_t *mailbox, message_t *msg)
{
  //if this mailbox isn't empty, our synchronization stuff is broken
  assert(mailbox->msg == NULL);
  
  mailbox->msg = message_alloc();

  mailbox->msg->from = msg->from;
  mailbox->msg->header = msg->header;
  mailbox->msg->size = msg->size;
  mailbox->msg->pdata = msg->pdata;

}

message_t *mailbox_get (mailbox_t *mailbox)
{
  message_t *msg;
  
  assert(mailbox->msg != NULL);
  
  msg = mailbox->msg;
  
  mailbox->msg = NULL;
  
  return msg;
}

int mailbox_is_empty (mailbox_t *mailbox)
{
  if (mailbox->msg == NULL) {
    return 1;
  } else {
    return 0;
  }
}

int mailbox_is_full (mailbox_t *mailbox)
{
  if (mailbox->msg != NULL) {
    return 1;
  } else {
    return 0;
  }
}
