/*   
 *
 *   Copyright (c) 2003 Lonesome, OSDev Group & Peter Zotov
 *
 *   http://tyros.sourceforge.net/
 *   http://sourceforge.net/projects/tyros/
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2, or (at your option)
 *   any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program (see the file COPYING); if not, write to the
 *   Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 *   Boston, MA  02111-1307, USA
 *
 *
 */

#ifndef _NTX_H_
#define _NTX_H_

#include <tyros.h>
#include <ntxbase.h>

extern int stdout;
extern int stdin;
extern int stderr;

#define O_CREAT 	1
#define O_APPEND 	2
#define O_READ		3
#define O_WRITE		4

//posix compatible... at least yet :)
typedef struct stat {
  int         st_dev;      /* device */
  int         st_ino;      /* inode */
  int        st_mode;     /* protection */
  int       st_nlink;    /* number of hard links */
  int         st_uid;      /* user ID of owner */
  int         st_gid;      /* group ID of owner */
  int        st_rdev;     /* device type (if inode device) */
  fsize_t    st_size;     /* total size, in bytes */
  int     st_blksize;  /* blocksize for filesystem I/O */
  int      st_blocks;   /* number of blocks allocated */
  int       st_atime;    /* time of last access */
  int       st_mtime;    /* time of last modification */
  int       st_ctime;    /* time of last change */
} ntx_stat_t;

#define ST_IFDIR 0x0040000

int usyscall(int, int, int, int, int, int);
int uregister_rpc(int, void*, int);
int uinvoke_rpc(int, int, message_t *, int);
int uattach(int, int, int);
int udetach(int, int);
unsigned int uinport(unsigned int);
unsigned int uoutport(unsigned int, unsigned int);
int uload_task(void *, int, int);
int uload_thread(void *);
int uwait_msg(void);
int usend_msg(tid_t, message_t *, int);
int urecv_msg(message_t *, int);
int ureq_sys_mem(unsigned int, unsigned int, int);
int usend_signal(tid_t, signum_t);
int uset_sighandler(signum_t, func_t);
void *umorecore (int);
void *alloc_pmem(int);
int waitpid(int, int *, int);
int execve(char *, char **, char **);
int ntx_launch(char*, char **, char **);
int ntx_write(int, void*, int);
int ntx_read(int, void*, int);
void _exit(int);
void exit(int);
int chdir(char*);
int fork(void);
int ntx_open(char *, int);
int init_fd_table(void);
int add_fd(void);
int open(char *, int);
int gputs(char *);
int write(int, void*, int);
int read(int, void*, int);
int close(int);
int putchar(char);

#endif
