/*   
 *
 *   Copyright (c) 2003 Lonesome, OSDev Group & Peter Zotov
 *
 *   http://tyros.sourceforge.net/
 *   http://sourceforge.net/projects/tyros/
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2, or (at your option)
 *   any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program (see the file COPYING); if not, write to the
 *   Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 *   Boston, MA  02111-1307, USA
 *
 *
 */

#ifndef _NTXBASE_H_
#define _NTXBASE_H_

enum {NSE_OBJECT = 1,
      NSE_CONTAINER,
      NSE_MOUNTPOINT
};


typedef unsigned long long fsize_t;
typedef unsigned long long id_t;

#define MOUNTS_MAX 3

typedef struct {
  id_t id[MOUNTS_MAX];
  int vfsid[MOUNTS_MAX];
} file_t;


typedef struct {
  int ident;
  int size;
  int vfsid;
} nsstatus_t;


typedef struct nsentry_struct {
  
  int nse_type;

  int subcount;

  struct nsentry_struct **nsentry;
  struct nsentry_struct *backlink;
  file_t mounted;
  
  nsstatus_t nsstatus;
  id_t id;
  char **name;

} nsentry_t;

typedef struct kex_st {
  char *filename;
  void *memarea;
  void *init;
  void *cleanup;
  char *name;
} kex_t;

typedef struct kex_registry_st {
  kex_t **kex;
  int count;
} kex_registry_t;


int write_file (file_t file, fsize_t start, fsize_t fsize, void *buffer);
int read_file (file_t file, fsize_t start, fsize_t fsize, void *buffer);

#endif
