/*   
 *
 *   Copyright (c) 2003 Lonesome, OSDev Group & Peter Zotov
 *
 *   http://tyros.sourceforge.net/
 *   http://sourceforge.net/projects/tyros/
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2, or (at your option)
 *   any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program (see the file COPYING); if not, write to the
 *   Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 *   Boston, MA  02111-1307, USA
 *
 *
 */

#ifndef _PROCESS_H_
#define _PROCESS_H_

#include <tyros.h>
#include "mailbox.h"
#include "heap.h"
#include "ntxbase.h"
#include <vfs.h>

typedef struct {
  
  heap_t *heap;
  mailbox_t *mailbox;
  int pagedir;
  file_t nsentry;

  char argstr[PATH_MAX];
  char exe[PATH_MAX];
  char environ[ENV_MAX];
  

  int rpc_count;
  void **rpc_handler;

  fd_t fd[USER_FDS_MAX];
  
  char cwd[PATH_MAX];

} process_t;



#endif
