/*   
 *
 *   Copyright (c) 2003 Lonesome, OSDev Group & Peter Zotov
 *
 *   http://tyros.sourceforge.net/
 *   http://sourceforge.net/projects/tyros/
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2, or (at your option)
 *   any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program (see the file COPYING); if not, write to the
 *   Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 *   Boston, MA  02111-1307, USA
 *
 *
 */

/*
 * rpc.c - Realtime Procedure Call / Realtime Message Passing
 * 
 *
 */

#include <tyros.h>
#include "core.h"

int ipc_register_rpc_handler (int vector, void *handler, int flags)
{
  //  printf("RPC Register: tid: %i, vector: %i, handler: %X, flags: %i\n",
  //	 tasks.current, vector, handler, flags);

  return process_add_rpc_handler (me, vector, handler, flags);
}

int ipc_invoke_rpc_handler (int tid, int vector, message_t *msg, int flags)
{
  void *newpdata;
  message_t *newmsg;
  int result;

  newpdata = it_msg_copy (tasks.current, tid, msg->pdata, msg->size);
  newmsg = malloc(sizeof(message_t));
  
  newmsg->header = msg->header;
  newmsg->size = msg->size;
  newmsg->pdata = newpdata;

  isem_disable();
  
  result = process_invoke_rpc_handler(tid, vector, newmsg, flags);
  
  free(newmsg);
  isem_enable();

//  printf("RPC Call, tid: %i, vector: %i, msg->header: %i, flags: %i\n",
//	 tid, vector, msg->header, flags);
  
  return result;
}
