/*   
 *
 *   Copyright (c) 2003 Lonesome, OSDev Group & Peter Zotov
 *
 *   http://tyros.sourceforge.net/
 *   http://sourceforge.net/projects/tyros/
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2, or (at your option)
 *   any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program (see the file COPYING); if not, write to the
 *   Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 *   Boston, MA  02111-1307, USA
 *
 *
 */

#include <tyros.h>
#include <ntx.h>
#include <ntxbase.h>
#include <vfs.h>


int mount (char *c_device, char *c_point, int vfsid)
{
file_t mfile;
file_t device, point;

device = resolve_path(c_device);
point = resolve_path(c_point);

if (device.id[0] != 0 && point.id[0] != 0) 
 {
 int (*mount_func) (file_t, file_t);
 mount_func = vfs_registry->vfs_handler[vfsid]->mount_func;
 
 if(mount_func)
  {
  if(mount_func(device, point) == -1)
   return -1;
  }
 nsentry_t* nspoint = point.id[0];
 nspoint->nsstatus.vfsid = vfsid;
 nspoint->mounted = device;
 return 0;
 }
else
 return -1;
}
