/*   
 *
 *   Copyright (c) 2003 Lonesome, OSDev Group & Peter Zotov
 *
 *   http://tyros.sourceforge.net/
 *   http://sourceforge.net/projects/tyros/
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2, or (at your option)
 *   any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program (see the file COPYING); if not, write to the
 *   Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 *   Boston, MA  02111-1307, USA
 *
 *
 */

#include <tyros.h>
#include <ntx.h>
#include <ntxbase.h>
#include <vfs.h>
#include <core.h>

nsentry_t *get_nsentry(nsentry_t *base, char *path, char **newpath, int **vfsid);


file_t resolve_path (char *path)
{
nsentry_t *v_id = NULL, *ns = NULL;
file_t result = {0};
char *newpath = NULL;
char *npath = NULL;
nsentry_t *device = NULL; 
char abspath[PATH_MAX];
id_t resid = 0;
int vfsid = 0;
int len;
  
if(!strcmp(path, "")) 
 return resolve_path(me->cwd);

//this is crude hack (it changes the path param)
//but everything should be OK
len = strlen(path);
if(len > 1) 
 if(path[len -1] == '/') 
  path[len - 1] = 0;

if(*path == '/') 
 {
 if(*(path + 1) == 0) 
  return root;
 else
  v_id = get_nsentry(root.id[0], path + 1, &newpath, &vfsid);
 }
else 
 {
 strcpy(abspath, me->cwd);
 strcat(abspath, path);
 v_id = get_nsentry(root.id[0], abspath + 1, &newpath, &vfsid);
 }
  
if(v_id == NULL) 
 {
 result.id[0] = 0;
 return result;
 }

result.id[0] = (id_t) v_id;
result.vfsid[0] = vfsid;
result.id[1] = (id_t) -1;

if(newpath != NULL) 
 {
 //    printf("Mountpoint: '%s' is on another filesystem\n", newpath);
 
 device = v_id->mounted.id[0];
    
 result.id[0] = (id_t) device;
 resid = vfs_registry->vfs_handler[v_id->nsstatus.vfsid]->resolve_func(result, newpath, &npath);
 if(resid == -1) 
  {
  result.id[0] = NULL;
  return result;
  }
 result.id[1] = (id_t) resid;
 result.id[2] = (id_t) -1;
 }
return result;
}

nsentry_t *get_nsentry(nsentry_t *base, char *path, char **newpath, int **vfsid)
{
  int i;
  nsentry_t *newbase;
  char *start;
  nsentry_t *ret;
  char back;

  start = path;

  if(base->mounted.id[0] != NULL) {
    //    printf("'%s' - mount detected\n", path);
    ret = base;
    *newpath = path;
    *vfsid = base->nsstatus.vfsid;
    return ret;
  }
  
  while(*path != '/' && *path != 0) {
    path++;
  }
  
  back = *path;
    *path = 0;
    
    i = 0;
    
    while( base->nsentry[i] != NULL &&  (strcmp(base->name[i], start)) ){
      i++;
    }
    
    
    *path = back;

    if(base->nsentry[i] == NULL) {
      return 0;
    } else {
      
      
      ret = base->nsentry[i];
   
      if(*path == 0 || (*path == '/' && *(path + 1) == 0)) {
	
	if(base->nsentry[i]->mounted.id[0] == NULL) {
	  *newpath = NULL;
	  return ret;
	} else {
	  *vfsid = base->nsentry[i]->nsstatus.vfsid;
	  *newpath = path;
	  return ret;
	}
      } else {
	return get_nsentry(ret, path + 1, newpath, vfsid);
      }    
    }

  
  
}
