/*   
 *
 *   Copyright (c) 2003 Lonesome, OSDev Group & Peter Zotov
 *
 *   http://tyros.sourceforge.net/
 *   http://sourceforge.net/projects/tyros/
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2, or (at your option)
 *   any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program (see the file COPYING); if not, write to the
 *   Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 *   Boston, MA  02111-1307, USA
 *
 *
 */

#include <tyros.h>

int request_system_memory_area (unsigned int address, int npages, int flags)
{
  task_t *task = tasks.task[tasks.current];
  unsigned int pagedir;
  int i;
  
  if(task->pl == 0) {
    
    pagedir = task->pagedir;
    
    
    for(i = 0; i < npages; i++) {
      map_memory_page (address + i*0x1000, address + i*0x1000, pagedir, 0x7);
    }
  
    return 0;
    
  } else {
    return -1;
  }
}

