/*   
 *
 *   Copyright (c) 2003 Lonesome, OSDev Group & Peter Zotov
 *
 *   http://tyros.sourceforge.net/
 *   http://sourceforge.net/projects/tyros/
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2, or (at your option)
 *   any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program (see the file COPYING); if not, write to the
 *   Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 *   Boston, MA  02111-1307, USA
 *
 *
 */

#include <tyros.h>
#include <ntx.h>
#include <ntxbase.h>
#include <filesystems.h>
#include <devfs.h>

#define COM1_IO		0x3F8
#define COM2_IO		0x2F8
#define COM3_IO		0x3E8
#define COM4_IO		0x3E8
#define COM13_IRQ	0x24
#define COM24_IRQ	0x23

IRQ_HANDLER(com13_interrupt)
{
printf("rs232: 1/3 irq!\n");
}

IRQ_HANDLER(com24_interrupt)
{
printf("rs232: 2/4 irq!\n");
}

void init_rs232(nsentry_t *dev)
{
printf("rs232: initializing...\n");

i_install(COM13_IRQ, &com13_interrupt, RING0 | INTERRUPT_GATE);
i_install(COM24_IRQ, &com24_interrupt, RING0 | INTERRUPT_GATE);
i_enable();
printf("rs232: installed interrupts\n");


}
