/*   
 *
 *   Copyright (c) 2003 Lonesome, OSDev Group & Peter Zotov
 *
 *   http://tyros.sourceforge.net/
 *   http://sourceforge.net/projects/tyros/
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2, or (at your option)
 *   any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program (see the file COPYING); if not, write to the
 *   Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 *   Boston, MA  02111-1307, USA
 *
 *
 */

#ifndef _HANDLERS_H_
#define _HANDLERS_H_


/* some ugly macros */
#define IRQ_HANDLER(func) void func (void);\
 asm(".globl " #func " \n " #func ": cli \n pusha \n call _" #func " \n movb $0x20, %al \n outb %al, $0x20 \n popa \n sti \n iret \n");\
 void _ ## func(void)

#define EXCEPTION_HANDLER(func) void func (unsigned int errcode);\
 asm(".globl " #func " \n " #func ": popl " #func  "_errcode \n "\
 "popl " #func "_address \n pushl " #func "_address \n pusha \n pushl " #func "_errcode \n"\
 "pushl " #func "_address \n call _" #func " \n addl $8, %esp \n popa \n iret \n "\
 #func "_errcode: .long 0 \n" #func "_address: .long 0");\
 void _ ## func(unsigned int address, unsigned int errcode)


#define TASK_GATE_IRQ_HANDLER(func) void func (void);\
 asm(".globl " #func " \n " #func ": call _" #func " \n movb $0x20, %al \n outb %al, $0x20 \n iret \n");\
 void _ ## func(void)
/* ---------------------- */


void divide_error(unsigned int errcode);
void debug_exception(unsigned int errcode);
void nmi_interrupt(unsigned int errcode);
void breakpoint_trap(unsigned int errcode);
void overflow_exception(unsigned int errcode);
void bound_exception(unsigned int errcode);
void invalid_opcode(unsigned int errcode);
void no_math(unsigned int errcode);
void double_fault(unsigned int errcode);
void invalid_tss(unsigned int errcode);
void segment_not_present(unsigned int errcode);
void stack_fault(unsigned int errcode);
void general_protection(unsigned int errcode);
void page_fault(unsigned int errcode);
void fpu_error(unsigned int errcode);
void alignment_exception(unsigned int errcode);
void machine_exception(unsigned int errcode);
void simd_error(unsigned int errcode);
void int_syscall(void);

#endif
