/*   
 *
 *   Copyright (c) 2003 Lonesome, OSDev Group & Peter Zotov
 *
 *   http://tyros.sourceforge.net/
 *   http://sourceforge.net/projects/tyros/
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2, or (at your option)
 *   any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program (see the file COPYING); if not, write to the
 *   Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 *   Boston, MA  02111-1307, USA
 *
 *
 */

#ifndef _KTTY_H_
#define _KTTY_H_

#define VIDEO_RAM 0xb8000
#define VIDEO_WIDTH 80
#define VIDEO_HEIGHT 25

#define TTY_ESCAPE_MOVEX 0x01
#define TTY_ESCAPE_MOVEY 0x02

#define TTY_MODE_BUFFERED 0x01
#define TTY_MODE_UNBUFFERED 0x02

void textcolor(char c);
void init_tty(void);
void move(int x, int y);
void mvprintf(int x, int y, char *fmt, ...);
void clear();
void putdec(unsigned int byte);
void puthexi(unsigned int dword);
void puthex(unsigned char byte);
void puthexd(unsigned char digit);
void puts(const char *s);
char getc(void);
void vprintf(const char *fmt, va_list args);
void printf(const char *fmt, ...);

#endif
