/*   
 *
 *   Copyright (c) 2003 Lonesome, OSDev Group & Peter Zotov
 *
 *   http://tyros.sourceforge.net/
 *   http://sourceforge.net/projects/tyros/
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2, or (at your option)
 *   any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program (see the file COPYING); if not, write to the
 *   Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 *   Boston, MA  02111-1307, USA
 *
 *
 */

#ifndef _TASKMAN_H_
#define _TASKMAN_H_

unsigned int add_task(task_image_t task_image,
		      unsigned int page_directory,
		      int pl);

void give_up(void);
unsigned int mem_to_pages(unsigned int mem);
void kill_task(int qid);



extern unsigned int ticks_counter;

typedef struct tasks_startup_params_st {
  void *entry_point;
  unsigned int pagedir;
  unsigned int eip;
  unsigned int esp;
} tsp_t;

extern struct tasks_table_st tasks;


enum {TS_READY = 0,
      TS_SUSPENDED
};

enum {RS_NONE = 0,
      RS_AWAITING_MESSAGE,
      RS_AWAITING_RECIPIENT,
      RS_WAITING_PID_DIE,
      RS_WAITING_WHILE_ZERO

};

#endif
