/*   
 *
 *   Copyright (c) 2003 Lonesome, OSDev Group & Peter Zotov
 *
 *   http://tyros.sourceforge.net/
 *   http://sourceforge.net/projects/tyros/
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2, or (at your option)
 *   any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program (see the file COPYING); if not, write to the
 *   Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 *   Boston, MA  02111-1307, USA
 *
 *
 */

#ifndef _VM_H_
#define _VM_H_

void init_paging();
unsigned int create_user_address_space(unsigned int physical_start, unsigned int size);
void identity_map(unsigned int *pagedir, unsigned int pflags);
unsigned int build_page_directory();
unsigned int get_pte (unsigned int from, unsigned int pagedir_addr);
void set_pte (unsigned int from, unsigned int pagedir_addr, unsigned int pde_flags, unsigned int value);
void map_memory_page(unsigned int from, unsigned int to, unsigned int pagedir_addr, int pflags);
int vm_pagefault(unsigned int cr2);
void load_cr3(unsigned int pagedir);
unsigned int alloc_vpage(int tid);


//flags for PTE

#define VM_PAGE_NOT_EXISTS 0x00000000
#define VM_PAGE_ALLOCATED  0x00000002

#define VM_PAGE_COPY_ON_WRITE 0x00000800

#define VM_UNRESOLVED -1

#endif
