/*
 *   ioports.c - HAL-level input/output routines 
 *
 *
 *   Copyright (c) 2003 Lonesome & OSDev Group
 *
 *   http://tyros.sourceforge.net/
 *   http://sourceforge.net/projects/tyros/
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2, or (at your option)
 *   any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program (see the file COPYING); if not, write to the
 *   Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 *   Boston, MA  02111-1307, USA
 *
 *
 */

#include <tyros.h>


inline void outportb(unsigned short port, unsigned char value)
{
  asm("outb %b0,%w1":: "a"(value), "d"(port));
}

inline char inportb(unsigned short port)
{
  char value;

  asm("inb %w1, %b0": "=a"(value): "d"(port));

  return value;
}

inline void outportw(unsigned short port, unsigned short value)
{
  asm("outw %%ax, %%dx"::"a"(value),"d"(port));
}

inline short inportw(unsigned short port)
{
  short value;

  asm("inw %%dx, %%ax":"=a"(value):"d"(port));

  return value;
}
