/*
 *   panic.c - neat pink screen of death :) 
 *
 *
 *   Copyright (c) 2003 Lonesome & OSDev Group
 *
 *   http://tyros.sourceforge.net/
 *   http://sourceforge.net/projects/tyros/
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2, or (at your option)
 *   any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program (see the file COPYING); if not, write to the
 *   Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 *   Boston, MA  02111-1307, USA
 *
 *
 */


#include <tyros.h>
#include <stdarg.h>

void panic(char *fmt, ...)
{
  task_t *task = tasks.task[tasks.current];
  va_list vl;
  
    
  i_disable();

  va_start(vl, fmt);

  

  /*  
  clear();
  */
  
  textcolor(COLOR_WHITE + COLOR_LMAGENTA*0x10);
  printf("Task %i has caused an unrecoverable error:", tasks.current);
  textcolor(7);

  printf("\n\n");

  vprintf(fmt, vl);
  
  
  
  //  printf("\nStack0 contents:\n");
  //  display_stack0(task->stack0);
  
  
  
  i_disable();
  for(;;);
  
  va_end(vl);
}
