/*   
 *
 *   Copyright (c) 2003 Lonesome, OSDev Group & Peter Zotov
 *
 *   http://tyros.sourceforge.net/
 *   http://sourceforge.net/projects/tyros/
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2, or (at your option)
 *   any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program (see the file COPYING); if not, write to the
 *   Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 *   Boston, MA  02111-1307, USA
 *
 *
 */

#ifndef _TYROS_H_
#define _TYROS_H_

#include <stdarg.h>

#include "../hal/ia32/include/hal.h"

//Some types
typedef unsigned char uint8_t;
typedef unsigned short uint16_t;
typedef unsigned int uint32_t;

#define INFOFS_FILE_VERSION "Tyros/Neutronix Version 0.02 Pre-1\n"

//Kernel entry point
void kernel_main(void);


#define FONT_WIDTH 8
#define FONT_HEIGHT 8


#define SCREEN_WIDTH 800
#define SCREEN_HEIGHT 600

#define CON_WIDTH (700/FONT_WIDTH)
#define CON_HEIGHT (400/FONT_HEIGHT)

#define CON_BASEX 50
#define CON_BASEY 100

#define PROCESSES_MAX 1024

#define PATH_MAX 0x1000
#define ENV_MAX 0x1000

#define USER_FDS_MAX 1024

#define TASK_PAGES_MAX 0x1000

#define USER_HEAP_START 0xA0000000
#define USER_INITIAL_HEAP_SIZE 10000

#define STACK0_SIZE 0x1000
#define USER_ADDRESS_SPACE_START 0x80000000
#define USER_TASK_ENTRY 0x80000000
#define USER_STACK_START 0xA0000000-4
#define USER_SPACE_FOR_STACK 0x100000

#define LFB_MAPPING 0x70000000

#endif
