/*   
 *
 *   Copyright (c) 2003 Lonesome, OSDev Group & Peter Zotov
 *
 *   http://tyros.sourceforge.net/
 *   http://sourceforge.net/projects/tyros/
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2, or (at your option)
 *   any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program (see the file COPYING); if not, write to the
 *   Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 *   Boston, MA  02111-1307, USA
 *
 *
 */

#include <tyros.h>
#include <ntx.h>
#include <stdarg.h>

void puthex(unsigned char byte);
void puthexd(unsigned char digit);
void dvprintf(const char *fmt, va_list args);

void printf(const char *fmt, ...)
{
  char buffer[0x1000];
  va_list args;
  va_start(args, fmt);

  //  vsprintf(buffer, fmt, args);
  //  write(stdout, buffer, strlen(buffer));
  dvprintf(fmt, args);

  va_end(args);
}
void putdec(unsigned int byte)
{
  unsigned char b1;
  int b[30];
  signed int nb;
  int i=0;
  
  while(1){
    b1=byte%10;
    b[i]=b1;
    nb=byte/10;
    if(nb<=0){
      break;
    }
    i++;
    byte=nb;
  }
  
  for(nb=i+1;nb>0;nb--){
    puthexd(b[nb-1]);
  }
}

void puthexi(unsigned int dword)
{
  puthex( (dword & 0xFF000000) >>24);
  puthex( (dword & 0x00FF0000) >>16);
  puthex( (dword & 0x0000FF00) >>8);
  puthex( (dword & 0x000000FF));
}


void puthex(unsigned char byte)
{
 unsigned  char lb, rb;

  lb=byte >> 4;
  
  rb=byte & 0x0F;
  
  
  puthexd(lb);
  puthexd(rb);
}

void puthexd(unsigned char digit)
{
  char table[]="0123456789ABCDEF";
   putchar(table[digit]);
}


void puts(const char *s)
{
  while(*s) {
    putchar(*s);
    s++;
  }
}


void dvprintf(const char *fmt, va_list args)
{
  char *str;
  
  while (*fmt) {
    
    switch (*fmt) {
    case '%':
      fmt++;

      switch (*fmt) {
      case 's':
	str = (va_arg(args, char *));
	if(str != NULL) {
	  puts(str);
	} else {
	  puts("(null)");
	}
	break;
	
      case 'c':
	putchar(va_arg(args, unsigned int));
	break;
	
      case 'i':
      case 'd':
	putdec(va_arg(args, unsigned int));
	break;

      case 'x':
	puthex(va_arg(args, unsigned int));
	break;
	
      case 'X':
	puthexi(va_arg(args, unsigned int));
	break;

      case '%':
	putchar('%');
	break;
	
      }
      

      break;
      
    default:
      putchar(*fmt);
      break;
    }

    fmt++;
  }
}

