/*
 *   string.c - klibc stdio functions 
 *
 *   Copyright (c) 2003 Lonesome & OSDev Group
 *
 *   http://tyros.sourceforge.net/
 *   http://sourceforge.net/projects/tyros/
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2, or (at your option)
 *   any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program (see the file COPYING); if not, write to the
 *   Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 *   Boston, MA  02111-1307, USA
 *
 *
 */  



#include <tyros.h>
#include <ntx.h>

char *sputhexd(char *str, unsigned char digit);

/* everything is AWFUL */
/* TODO: rewrite everything :) */

void vprintf(const char *fmt, va_list args)
{
  char buffer[512];
  
  vsprintf(buffer, fmt, args);
  
  puts(buffer);
}

int sprintf (char *str, const char *fmt, ...)
{
  int r;
  
  va_list args;
  va_start(args, fmt);
  
  r = vsprintf(str, fmt, args);
  
  va_end(args);
  return r;
}

void abort(void)
{
  panic("ABORT called!\n");
}

int sscanf (char *str, char *fmt, ...)
{
  panic("SSCANF called!\n");
}

char *sputchar (char *str, int c)
{
  *str = c;
  return (str + 1);
}

char *sputs(char *str, char *s)
{
  while(*s) {
    str = sputchar(str, *s);
    s++;
  }
  return str;
}

char *sputhex (char *str, char byte)
{
  unsigned  char lb, rb;

  lb=byte >> 4;
  rb=byte & 0x0F;
  str = sputhexd(str, lb);
  str = sputhexd(str, rb);
  
  return str;
}

char *sputhexd(char *str, unsigned char digit)
{
  char table[]="0123456789ABCDEF";
  str = sputchar(str, table[digit]);
  return str;
}

char *sputhexi(char *str, unsigned int dword)
{
  str = sputhex(str, (dword & 0xFF000000) >>24);
  str = sputhex(str, (dword & 0x00FF0000) >>16);
  str = sputhex(str, (dword & 0x0000FF00) >>8);
  str = sputhex(str, (dword & 0x000000FF));
  return str;
}


char *sputdec(char *str, unsigned int byte)
{
  unsigned char b1;
  int b[30];
  signed int nb;
  int i=0;
  
  while(1){
    b1=byte%10;
    b[i]=b1;
    nb=byte/10;
    if(nb<=0){
      break;
    }
    i++;
    byte=nb;
  }
  
  for(nb=i+1;nb>0;nb--){
    str = sputhexd(str, b[nb-1]);
  }

  return str;
}


int vsprintf(char *str, const char *fmt, va_list args)
{
  char *base;

  base = str;

  while (*fmt) {
    
    if(*fmt == '%') {
      fmt++;

      //There IS a reason i don't use switch here
      if(*fmt == 's') {
	str = sputs(str, va_arg(args, char *));
      } else if(*fmt == 'c') {
      	str = sputchar(str, va_arg(args, unsigned int));
      } else if(*fmt == 'i') {
	str = sputdec(str, va_arg(args, unsigned int));
      } else if(*fmt == 'x') {
	str = sputhex(str, va_arg(args, unsigned int));
      } else if(*fmt == 'X') {
	str = sputhexi(str, va_arg(args, unsigned int));
      }
      
    } else {
      str = sputchar(str, *fmt);
    }

    fmt++;
  }
  *str = 0;
  
  return (str - base);
}

void perror (char *s)
{
if(s != NULL) 
 printf("error: %s\n", s);
else
 printf("unknown error\n");
}
