/*   
 *
 *   Copyright (c) 2003 Lonesome, OSDev Group & Peter Zotov
 *
 *   http://tyros.sourceforge.net/
 *   http://sourceforge.net/projects/tyros/
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2, or (at your option)
 *   any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program (see the file COPYING); if not, write to the
 *   Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 *   Boston, MA  02111-1307, USA
 *
 *
 */

#include <tyros.h>
#include <ntx.h>
#include <stdarg.h>

int fprintf (int stream, char *fmt, ...)
{
  va_list vl;
  
  va_start(vl, fmt);
  
  vfprintf(stream, fmt, vl);
  
  va_end(vl);
}

int vfprintf (int stream, char *fmt, va_list vl)
{
  char buffer[0x1000];
  
  vsprintf(buffer, fmt, vl);
  
  return write (stream, buffer, strlen(buffer));
}

int fflush (int stream)
{
//no buffering is implemented yet, so no flushing is needed
return 0;
}

char *fgets (char *s, int size, int stream)
{
  int i;
  read (stream, s, size);
  for(i = 0; i < size; i++) {
    if(s[i] == '\n') {
      return s;
    }
  }
  
  return s;
}

int fopen (char *path, char *mode)
{
  int res;

  res = open(path, 0);
  
  if(res == -1) {
    return 0;
  } else {
    return res;
  }
}

int fread (void *ptr, int size, int nmemb, int stream)
{
  return (read(stream, ptr, size*nmemb))/size;
}

int fwrite (void *ptr, int size, int nmemb, int stream)
{
  return (write(stream, ptr, size*nmemb))/size;
}

int fclose (int stream)
{
  return close(stream);
}
