/*   
 *
 *   Copyright (c) 2003 Lonesome, OSDev Group & Peter Zotov
 *
 *   http://tyros.sourceforge.net/
 *   http://sourceforge.net/projects/tyros/
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2, or (at your option)
 *   any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program (see the file COPYING); if not, write to the
 *   Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 *   Boston, MA  02111-1307, USA
 *
 *
 */

#include <tyros.h>
#include <ntx.h>

extern int stdout, stdin, stderr;

char **parse_environ();
char **parse_argstr (int *argcount);

#define GLOBAL(x)asm(".globl " #x "\n " #x ": .long 0")

/* This MUSTN'T go to the .data section */
GLOBAL(environ);
GLOBAL(stderr);
GLOBAL(stdin);
GLOBAL(stdout);

extern char **environ;

void __init_libc()
{
  char **argv;
  char *filein = "/dev/vc", *fileout = "/dev/vc";
  int argc, i;

  init_mallocator();
  
  argv = parse_argstr (&argc);
  environ = parse_environ();
  
  //TODO: make these params cut out from code
  for(i=1; i<argc; i++)
   if(argv[i][0] == "<")
    {
    filein = &argv[i][1];
    }
   else if(argv[i][0] == ">")
    {
    fileout = &argv[i][1];
    }

  stderr = open("/dev/vc", 0);
  
  stdin  = open(filein, 0);
  if(!stdin)
   stdin = open("/dev/vc", 0);
   
  stdout = open(fileout, 0);
  if(!stdout)
   stdout = open("/dev/vc", 0);

  exit(main(argc, argv));
}

char **parse_environ()
{
  char **argv;
  char *buffer, *start;
  int cmdid;
  int argc;
  int i;

  argv = malloc(0x100);
  
  buffer = malloc(0x1000 + 0x10);
  
  cmdid = open("/sys/proc/self/environ", 0);

  if(cmdid == -1) {
    printf("ERROR: /sys/proc/self/environ unreadable\n");
    return NULL;
  }
  
  read (cmdid, buffer, 0x1000);
  
  argc = 0;
  i = 0;
  start = buffer;
  for(;;) {
    if(buffer[i] == 0) {
      argv[argc] = start;
      argc++;
      start = &buffer[i + 1];

      if(*start == 0) {
	break;
      }
    }
    
    i++;
  }

  
  return argv;
}

char **parse_argstr (int *argcount)
{
  char **argv;
  char *buffer, *start;
  int cmdid;
  int argc;
  int i;

  argv = malloc(0x100);
  
  buffer = malloc(0x2000);
  
  cmdid = open("/sys/proc/self/cmdline", 0);

  if(cmdid == -1) {
    gputs("ERROR: /sys/proc/self/cmdline unreadable\n");
    return NULL;
  }
  
  read (cmdid, buffer, 0x1000);
  
  argc = 0;
  i = 0;
  start = buffer;
  for(;;) {
    if(buffer[i] == 0) {
      argv[argc] = start;
      argc++;
      start = &buffer[i + 1];
      if(*start == 0) {
	break;
      }
    }
    
    i++;
  }

  *argcount = argc;
  
  return argv;
}
